> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/basic-operations/basics/html-to-pdf.md).

# Convert HTML to PDF in Xamarin

Convert HTML to PDF in Xamarin with a simple to use HTML to PDF API, includes code samples.

{% hint style="info" %}
**This tutorial only applies to Xamarin.Android. See Xamarin.iOS equivalent here .**
{% endhint %}

{% hint style="info" %}
**HTML to PDF conversion is available for Android API 19 and above.**
{% endhint %}

{% hint style="info" %}
Internet connection is not required when converting local HTML files. However, it is required for converting HTTP/HTTPS links.
{% endhint %}

The [HTML to PDF](https://sdk.apryse.com/api/xamarinandroid/tools/api/pdftron.PDF.Tools.Utils.HTML2PDF.html) conversion API accepts different sources, such as HTTP/HTTPS URLs, HTML strings, and everything that can be loaded in a [WebView](https://developer.android.com/reference/android/webkit/WebView.html).

## From link

To convert a link URL to PDF, simply:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
HTML2PDF hTML2PDF = new HTML2PDF(this);
hTML2PDF.FromUrl("http://developer.android.com/about/index.html");
hTML2PDF.ConversionFinished += (sender, e) =>
{
    // do something with e.PdfOutput
};
hTML2PDF.ConversionFailed += (sender, e) =>
{
    // error handling
};
```

{% endcode %}
{% endtab %}
{% endtabs %}

## From HTML string

To convert an HTML string to PDF, simply:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
HTML2PDF hTML2PDF = new HTML2PDF(this);
hTML2PDF.FromHTMLDocument(myBaseUrl, myHtmlData);
hTML2PDF.ConversionFinished += (sender, e) =>
{
    // do something with e.PdfOutput
};
hTML2PDF.ConversionFailed += (sender, e) =>
{
    // error handling
};
```

{% endcode %}
{% endtab %}
{% endtabs %}

where `myBaseUrl` is the URL to use as the page's base URL. If null defaults to `about:blank` and `myHtmlData` is a String of data in the `UTF-8` encoding. Click \[here for more info]\(<https://developer.android.com/reference/android/webkit/WebView.html#loadDataWithBaseURL(java.lang.String>, java.lang.String, java.lang.String, java.lang.String, java.lang.String)).

## From other sources

If none of the above fit your needs, you can also pass in a `WebView` directly for conversion:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
HTML2PDF hTML2PDF = new HTML2PDF(myWebview);
hTML2PDF.DoHtml2Pdf();
hTML2PDF.ConversionFinished += (sender, e) =>
{
    // do something with e.PdfOutput
};
hTML2PDF.ConversionFailed += (sender, e) =>
{
    // error handling
};
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/xamarin/basic-operations/basics/html-to-pdf.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
